import mongoose from 'mongoose';
import { RoleTypes } from './';
declare enum UserStatus {
    INVITED = "invited",
    ACTIVE = "active",
    INACTIVE = "inactive"
}
declare enum OnboardingStatus {
    SAVANNAH = "savannah",
    FARMLAND = "farmland",
    JUNGLE = "jungle",
    SEABASED = "seabased",
    HILL = "hill",
    SNOWCOVERED = "snowcovered",
    GATE = "gate",
    PERSONALSPACE = "personalspace"
}
declare enum Gender {
    MALE = "male",
    FEMALE = "femlae"
}
interface UserAttrs {
    id?: mongoose.Types.ObjectId;
    status: UserStatus;
    onboardingStatus: OnboardingStatus;
    userId: string;
    role: RoleTypes;
    username: string;
    displayName: string;
    firstName: string;
    lastName: string;
    profilePic: string;
    email?: string;
    gender: Gender;
    unverifiedEmail?: string;
    otp: mongoose.Types.ObjectId;
    isDeleted: boolean;
    createdBy: mongoose.Types.ObjectId;
    updatedBy: mongoose.Types.ObjectId;
}
export { UserStatus, OnboardingStatus, Gender, UserAttrs };
