import { Express } from 'express';
import { DefaultConfig, LogPath } from '../foundation';
import { CronJob, Routes } from '../interfaces';
declare abstract class BaseLoader {
    abstract set config(config: DefaultConfig);
    abstract set logPath(logPath: LogPath);
    abstract set cronJob(cronJob: CronJob);
    abstract set routes(routes: Routes);
    abstract set app(app: Express);
    abstract setup(isProcessRequired: boolean, isNconfRequired: boolean, isWinstonRequired: boolean, isDatabaseRequired: boolean, isCronRequired: boolean, isRoutesRequired: boolean): void;
    abstract load(): Promise<boolean>;
}
declare class Loader extends BaseLoader {
    private static _instance;
    private isProcessRequired;
    private isNconfRequired;
    private isWinstonRequired;
    private isDatabaseRequired;
    private isCronRequired;
    private isRoutesRequired;
    private environment;
    private _config;
    private _logPath;
    private _dbConnectionString;
    private _cronJob;
    private _routes;
    private _app;
    private constructor();
    static getInstance(): Loader;
    set config(config: DefaultConfig);
    set logPath(logPath: LogPath);
    set dbConnectionString(dbConnectionString: string);
    set cronJob(cronJob: CronJob);
    set routes(routes: Routes);
    set app(app: Express);
    setup(isProcessRequired: boolean, isNconfRequired: boolean, isWinstonRequired: boolean, isDatabaseRequired: boolean, isCronRequired: boolean, isRoutesRequired: boolean): void;
    load(): Promise<boolean>;
}
export { Loader, BaseLoader };
