import { Request, Response, NextFunction } from 'express';
import { ObjectSchema, ValidationError } from 'joi';
declare const requestValidate: (params: Partial<Record<Segments, ObjectSchema>>) => (request: Request, response: Response, next: NextFunction) => void;
declare const isRequestValidationError: (err: any) => boolean;
declare const requestValidationHandler: (err: any, req: Request, res: Response, next: NextFunction) => Promise<any>;
declare enum Segments {
    BODY = "body",
    COOKIES = "cookies",
    HEADERS = "headers",
    PARAMS = "params",
    QUERY = "query",
    SIGNEDCOOKIES = "signedCookies"
}
interface ValidateRequestError {
    details: Map<Segments, ValidationError>;
}
declare class ValidateRequestError implements ValidateRequestError {
    details: Map<Segments, ValidationError>;
    constructor();
}
export { requestValidate, ValidateRequestError, Segments, isRequestValidationError, requestValidationHandler };
